<?
/*
---------------------------------------------------------------------------------------------------------------------------------------
Dieses Script wird bei einem Update auf dem Zielsystem nach(!) dem Extrahieren des Update-Archivs ausgeführt und anschließend gelöscht.
---------------------------------------------------------------------------------------------------------------------------------------
*/

//Globale Includes
require(dirname(__FILE__)."/../www/shared/php/config.php");
require(MAIN_PATH."/www/shared/php/base.php");
require(MAIN_PATH."/main/include/php/update.php");
require(MAIN_PATH."/main/include/php/incl_log.php");
require(MAIN_PATH."/main/include/php/incl_process.php");
require(MAIN_PATH."/www/admin/include/php/base.php");	//für LBS-Import und VSE-Import

set_time_limit(0);

sql_connect();

$version=update_setVersion();	//die aktuelle Version (vor dem Update)

edomi_update_log(true,true,'EDOMI-Update auf Version '.global_version);
sleep(3);

if ($version!==false) {
	edomi_update_log(true,true,'Update-Script ausführen (von Version '.$version.' auf '.global_version.' updaten):');
	$tmp=edomi_update($version,true);
	edomi_update_log(true,true,'Update-Script beendet ('.$tmp.')');
	sleep(3);
} else {
	edomi_update_log(true,false,'Die aktuelle EDOMI-Version ist nicht ermittelbar, das Update-Script konnte daher nicht ausgeführt werden!');
	sleep(3);
}

update_syncEdomiIni();
sleep(3);
update_forceProjectActivation();
sleep(3);
update_importAllLBS();
sleep(3);
update_importAllVSE();
sleep(3);

//tmp_edomiupdate löschen
if (is_dir(MAIN_PATH.'/main/tmp_edomiupdate')) {exec('rm -rf '.MAIN_PATH.'/main/tmp_edomiupdate');}

edomi_update_log(true,true,'EDOMI-Update abgeschlossen');
sleep(3);

sql_disconnect();
exit();



function update_setVersion() {
	//neue Version in edomi.ini setzen und aktuelle Version des Zielsystems ermitteln
	$curVersion=false;
	$n=file(MAIN_PATH.'/edomi.ini');
	for ($t=0; $t<count($n); $t++) {
		if (trim($n[$t])!='' && substr(trim($n[$t]),0,1)!='#') {
			$var=explode('=',trim($n[$t]),2);
			if (count($var)==2) {
				if ($var[0]=='global_version') {
					$n[$t]="global_version='".global_version."'"."\n";
					$curVersion=$var[1];
				}
			}
		}
	}
	$tmp=implode('',$n);
	file_put_contents(MAIN_PATH.'/edomi.ini',$tmp);
	
	$curVersion=preg_replace("/[^\.0-9]+/i",'',$curVersion);
	return $curVersion;
}

function update_importAllLBS() {
	//frischt alle LBS-Definitionen auf
	edomi_update_log(true,true,'Logikbausteine einlesen');
	lbs_importAll(true);
}

function update_importAllVSE() {
	//frischt alle VSE-Definitionen auf
	edomi_update_log(true,true,'Visuelemente einlesen');
	vse_importAll(true);
}

function update_forceProjectActivation() {
	//erzwingt die Neuaktivierung des Projekts
	edomi_update_log(true,true,'Projektaktivierung erzwingen');
	sql_call("DROP TABLE IF EXISTS edomiLive.logicElement");
}

function update_syncEdomiIni() {
	//kopiert alle (verfügbaren) Parameter-Werte der User-INI in die Vorlage tmp_edomiupdate/tmp.ini (die Vorlage wird vom Compiler stets automatisch auf der Grundlage der aktuellen INI im Devel-System generiert - natürlich bereinigt)
	//anschließend ersetzt tmp.ini die User-INI!
	edomi_update_log(true,true,'Basis-Konfiguration synchronisieren');
	$fnUsr=MAIN_PATH.'/edomi.ini';
	$fnTmp=MAIN_PATH.'/main/tmp_edomiupdate/tmp.ini';
	
	if (file_exists($fnTmp)) {
		$iniUsr=file($fnUsr);
		$iniTmp=file($fnTmp);
	
		//User-INI durchgehen
		for ($t=0; $t<count($iniUsr); $t++) {
			if (trim($iniUsr[$t])!='' && substr(trim($iniUsr[$t]),0,1)!='#') {
				$varUsr=explode('=',trim($iniUsr[$t]),2);
				if (count($varUsr)==2) {				

					//Eintrag in TMP auf User-INI-Wert setzen
					for ($tt=0; $tt<count($iniTmp); $tt++) {
						if (trim($iniTmp[$tt])!='' && substr(trim($iniTmp[$tt]),0,1)!='#') {
							$varTmp=explode('=',trim($iniTmp[$tt]),2);
							if (count($varTmp)==2 && trim($varTmp[0])==trim($varUsr[0])) {
								$iniTmp[$tt]=trim($varTmp[0]).'='.trim($varUsr[1])."\n";
							}
						}
					}

				}
			}
		}
		
		//User-INI überschreiben
		$n=implode('',$iniTmp);
		file_put_contents(MAIN_PATH.'/edomi.ini',$n);
	}
}
?>
