###[DEF]###
[name			=	Gartenbewässerung]

[e#1	TRIGGER	=	Bewässerungszyklus				#init=0		] ### z.B. ZSU als Zeitfenster - bei 0 wird auch das Ventil geschlossen!
[e#2	TRIGGER	=	Bodenfeuchte					#init=0		] Bodenfeuchte (für Schwellenwert)

[e#3	OPTION	=	Schwelle: Aus					#init=0		] Schwellenwert für Aus (>=)
[e#4	OPTION	=	Schwelle: Ein					#init=0		] Schwellenwert für Ein (<=)
[e#5	OPTION	=	min. Bewässerungszeit (Minuten)	#init=0		] min. Bewässerungszeit pro Zyklus (0=unendlich)
[e#6	OPTION	=	max. Bewässerungszeit (Minuten)	#init=0		] max. Bewässerungszeit pro Zyklus (0=unendlich)
[e#7	OPTION	=	min. Bewässerungsmenge (Liter)	#init=0		] min. Bewässerungsmenge pro Zyklus (0=unendlich)
[e#8	OPTION	=	max. Bewässerungsmenge (Liter)	#init=0		] max. Bewässerungsmenge pro Zyklus (0=unendlich)

[e#9			=	Literimpuls						#init=0		] Wasserzähler-Literimpuls: 1=Literimpuls


[a#1			=	Ventil							]
[a#2			=	Bewässerungszeit				] ### pro Zyklus (wird erst beim nächsten Start resettet) in Minuten
[a#3			=	Bewässerungsmenge				] ### dto., und: stimmt natürlich nur, wenn keine andere Wasserentnahme stattgefunden hat (oder ein dedizierter Wasserzähler vorhanden ist)


[v#1			=0						] Zeit
[v#2			=0						] Menge
[v#3			=0						] interner Status: 0=bereit, 1=Bewässerung ist aktiv
###[/DEF]###


###[HELP]###
<b>ACHTUNG: Diese Hilfe ist noch unvollständig!</b>

- beim EDOMI-Start mit E1=0 wird A1 zur Sicherheit auf 0 gesetzt (die anderen Ausgänge bleiben unverändert)
	- E1 ist der Masterschalter, d.h. =0 führt immer zur sofortigen Deaktivierung
	- E1=1: es wird Bewässert bzw. gewartet bis Schwelle erreicht ist
	- nachdem die Bewässerung gestartet wurde, muss E1=0 gesetzt werden, damit ein neuer Zyklus gestartet werden kann!
	- wird also E1 auf 1 belassen, wird nur einmalig Bewässert!
	
- A2/A3 werden nur am Ende einer Bewässerung ausgegeben (und bleiben dann bestehen, bis wieder eine Bewässerung beendet ist)
	- wird per E1=0 abgebrochen, wird A2/A3 auch gesetzt (mit den bis dahin aufgelaufenen Werten)
- cave: A9 (Literimpuls) setzt entweder einen dedizierten Bewässerungs-Zähler voraus, oder es muss sichergestellt werden, dass keine andere Wasserentnahme im Bewässerungszeitfenster stattfindet
- A2: Minuten mit 1 NK

- an E1 ggf. auch ein SysKO legen, dass beim Shutdown eine 0 an E1 anlegt (damit Ventil geschlossen wird beim EDOMI-Ende)

- minimale Zeit/Menge: was zuerst zutrifft gewinnt
	- wenn die minimale Zeit/Menge erreicht ist, muss natürlich noch die Feuchte passen (Schwelle)
- maximale Zeit/Menge hat Prio gegenüber den Mindestwerten
	- es wird also nur dann die Mindestmenge/Zeit eingehalten, wenn diese nicht mit den Max-Werten kollidieren
	- Beispiel: nach 1 Minute soll Schluss sein - dann ist das auch so, auch wenn die Mindestmenge nicht erreicht wurde
	- die Feuchte wird dann natürlich ignoriert!
	
###[/HELP]###


###[LBS]###
<?
function LB_LBSID($id) {
	if (($E=logic_getInputs($id)) && ($V=logic_getVars($id))) {

		//Deaktivieren?
		if ($E[1]['value']==0 && $E[1]['refresh']==1) {
			logic_setOutput($id,1,0);

			if ($V[1]>0 || $V[2]>0) {
				logic_setOutput($id,2,round((getMicrotime()-$V[1])/60,1));
				logic_setOutput($id,3,$V[2]);
				logic_setVar($id,1,0);
				logic_setVar($id,2,0);
			}

			$V[3]=0;
			logic_setVar($id,3,$V[3]);

			logic_setState($id,0);

		} else {
		
			if (logic_getState($id)==0) {
	
				//Aktiviert und bereit?
				if ($E[1]['value']==1 && $V[3]==0) {
				
					//Schwellenwert Ein erreicht?
					if ($E[2]['value']<=$E[4]['value']) {
						logic_setOutput($id,1,1);

						$V[1]=getMicrotime();
						logic_setVar($id,1,$V[1]);
						$V[2]=0;
						logic_setVar($id,2,$V[2]);
						$V[3]=1;
						logic_setVar($id,3,$V[3]);
	
						logic_setState($id,1,1000,true); 
					}
				}
	
			} else {
	
				//Literimpuls
				if ($E[9]['value']!=0 && $E[9]['refresh']==1) {
					$V[2]++;
					logic_setVar($id,2,$V[2]);
				}

				//Maximalzeit oder(!) Maximalmenge erreicht?
				if (($E[6]['value']!=0 && (getMicrotime()-$V[1])/60>=$E[6]['value']) || ($E[8]['value']!=0 && $V[2]>=$E[8]['value'])) {
					logic_setOutput($id,1,0);
					logic_setOutput($id,2,round((getMicrotime()-$V[1])/60,1));
					logic_setOutput($id,3,$V[2]);

					logic_setState($id,0);
	
				} else {
					//Mindestzeit oder(!) Mindestmenge erreicht (oder beides deaktiviert)?
					if (($E[5]['value']==0 && $E[7]['value']==0) || ($E[5]['value']!=0 && (getMicrotime()-$V[1])/60>=$E[5]['value']) || ($E[7]['value']!=0 && $V[2]>=$E[7]['value'])) {
						//Schwellenwert Aus erreicht?
						if ($E[2]['value']>=$E[3]['value']) {
							logic_setOutput($id,1,0);
							logic_setOutput($id,2,round((getMicrotime()-$V[1])/60,1));
							logic_setOutput($id,3,$V[2]);

							logic_setState($id,0);
						}
					}
				}
			}
		}
	}
}
?>
###[/LBS]###


###[EXEC]###
<?

?>
###[/EXEC]###
